#include <windows.h>
#include "geometry.h"
#include "matrix.h"
#include "draw.h"

int Width, Height;
Matrix current_rot;

const int MARGIN = 10;

Rotation *Ball;

void SetBall(Rotation *_Ball)
{
	Ball = _Ball;
}

void SetWindowSize(int _Width, int _Height)
{
	Width = _Width;
	Height = _Height;
}

_Point T(_Point point)
{
	_Point TPoint;
	TPoint.x = MARGIN + (1.0 / 2) * (point.x + 1) * (Width - 2 * MARGIN);
	TPoint.y = MARGIN + (-1.0 / 2) *  (point.y - 1) * (Height - 2 * MARGIN);
	return TPoint;
}

void Draw(HDC hdc)
{
	_Point triangle[3];
	triangle[0].x = 0.0;
	triangle[0].y = 0.5;
	triangle[1].x = 0.5;
	triangle[1].y = 0.0;
	triangle[2].x = -0.5;
	triangle[2].y = -0.5;
	for (int i = 0; i < 3; i++)
	{
		ApplyMatrixtoPoint(Ball->CurrentMatrix, triangle[i]);
		triangle[i] = T(triangle[i]);
	}
	for (int i = 0; i <= 3; i++)
	{
		int j = i % 3;
		if (i == 0)
		{
			MoveToEx(hdc, triangle[j].x, triangle[j].y, NULL);
		}
		else
		{
			LineTo(hdc, triangle[j].x, triangle[j].y);
		}
	}
}