#include <windows.h>
#include "draw.h"

const double PI = 3.141592653;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
char szClassName[] = "CG_2D_mouse_rotate";

////////////////////////////////////////////////////////////////////////////////////////////////////
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	HWND hWnd;  
	MSG lpMsg;
	WNDCLASS wc;

	//    
	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon		 = NULL;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = szClassName;

	//   
	if (!RegisterClass(&wc))
	{
		MessageBox(NULL, "    !", "", MB_OK);
		return 0;
	}

	//    
	hWnd = CreateWindow(
		szClassName,                //                     
		" 2D ::      - compgraphics.info", //  
		WS_OVERLAPPEDWINDOW,        //                                               
		50,   50,                   //      
		600,  600,                  //        
		(HWND) NULL,                //     NULL    
		(HMENU) NULL,               //                  
		(HINSTANCE)hInstance,       //    
		NULL    );                  //    lParam   WM_CREATE  

	if (!hWnd) 
	{
		MessageBox(NULL, "    !", "", MB_OK);
		return 0;
	}

	//   
	ShowWindow(hWnd, nCmdShow); 
	UpdateWindow(hWnd);

	//       
	while (GetMessage(&lpMsg, NULL, 0, 0))
	{
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}

	return (lpMsg.wParam);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc(HWND hWnd, UINT messg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	RECT Rect;
	HDC hdc, hCmpDC;
	HBITMAP hBmp;
	static Rotation *Ball;
	static int xx, yy;

	switch (messg)
	{
	case WM_CREATE:
		Ball = new Rotation();
		SetBall(Ball);
		break;

	case WM_PAINT:
		GetClientRect(hWnd, &Rect);
		hdc = BeginPaint(hWnd, &ps);
		SetBkColor(hdc, 0xEECCCC);
		//      
		hCmpDC = CreateCompatibleDC(hdc);
		hBmp = CreateCompatibleBitmap(hdc, Rect.right - Rect.left,
			Rect.bottom - Rect.top);
		SelectObject(hCmpDC, hBmp);
		//   
		LOGBRUSH br;
		br.lbStyle = BS_SOLID;
		br.lbColor = 0xEECCCC;
		HBRUSH brush;
		brush = CreateBrushIndirect(&br);
		FillRect(hCmpDC, &Rect, brush);
		DeleteObject(brush);
		// 
		Draw(hCmpDC);
		//   
		SetStretchBltMode(hdc, COLORONCOLOR);
		BitBlt(hdc, 0, 0, Rect.right - Rect.left, Rect.bottom - Rect.top,
			hCmpDC, 0, 0, SRCCOPY);
		DeleteDC(hCmpDC);
		DeleteObject(hBmp);
		hCmpDC = NULL;
		EndPaint(hWnd, &ps);
		break;

	case WM_SIZE:
		GetClientRect(hWnd, &Rect);
		SetWindowSize(Rect.right - Rect.left, Rect.bottom - Rect.top);
		break;

	case WM_ERASEBKGND:
		return 1;
		break;

	case WM_LBUTTONDOWN:
		Ball->InitRotation(LOWORD(lParam) - 300, HIWORD(lParam) - 300);
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	case WM_MOUSEMOVE:
		if (UINT(wParam) & MK_LBUTTON)
		{
			Ball->Rotate(LOWORD(lParam) - 300, HIWORD(lParam) - 300);
			xx = LOWORD(lParam);
			yy = HIWORD(lParam);
			InvalidateRect(hWnd, NULL, FALSE);
		}
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	default:
		return (DefWindowProc(hWnd, messg, wParam, lParam));
	}

	return (0);
}
